#include <stdio.h>

#define RT_END 1

int readFromHexInto(FILE *fp, int bufferSize, unsigned char *startPtr)
{
  int i, c, n;
  unsigned int recordLength, loadAddress, recordType, dataByte, checkSum;

  while ((c = fgetc(fp)) != EOF) {
    if (c == ':') {
      n = fscanf(fp, "%2lX%4lX%2lX", &recordLength, &loadAddress, &recordType);
      if (n != 3) {
	fprintf(stderr, "Could not read record data.\n");
	return -1;
      }
      if (recordType == RT_END) {
	return 0;
      }
      if (loadAddress + recordLength > bufferSize) {
	fprintf(stderr, "Out of Memory.\n");
	return -1;
      }
      for (i = 0; i < recordLength; i++) {
	n = fscanf(fp, "%2lX", &dataByte);
	if (n != 1) {
	  fprintf(stderr, "Line terminated at wrong point.\n");
	  return -1;
	}
	startPtr[loadAddress + i] = dataByte;
      }
      n = fscanf(fp, "%2lX", &checkSum);
      if (n != 1) {
	fprintf(stderr, "Check sum was not found.\n");
	return -1;
      }
    }
  }
  fprintf(stderr, "File ended while reading.\n");
  return -1;
}

